## galera-3 25.3.23

=== SConstruct ===
###################################################################
#
# Copyright (C) 2010-2017 Codership Oy <info@codership.com>
#
# SCons build script to build galera libraries
#
# How to control the build with environment variables:
# Set CC       to specify C compiler
# Set CXX      to specify C++ compiler
# Set CPPFLAGS to add non-standard include paths and preprocessor macros
# Set CCFLAGS  to *override* optimization and architecture-specific options
# Set CFLAGS   to supply C compiler options
# Set CXXFLAGS to supply C++ compiler options
# Set LDFLAGS  to *override* linking flags
# Set LIBPATH  to add non-standard linker paths
# Set RPATH    to add rpaths
#
# Some useful CPPFLAGS:
# GCS_SM_DEBUG          - enable dumping of send monitor state and history
# GU_DEBUG_MUTEX        - enable mutex debug instrumentation
# GU_DBUG_ON            - enable sync point macros
#
# Script structure:
# - Help message
# - Default parameters
# - Read commandline options
# - Set up and configure default build environment
# - Set up and configure check unit test build environment
# - Run root SConscript with variant_dir
#
####################################################################

import os
import platform
import string
import subprocess

# Execute a command and read the first line of its stdout.
# For example read_first_line(["ls", "-l", "/usr"])
def read_first_line(cmd):
    p = subprocess.Popen(cmd, stdout=subprocess.PIPE)
    stdout = p.communicate()[0]
    line = stdout.splitlines()[0]
    return line

sysname = os.uname()[0].lower()
machine = platform.machine()
bits = ARGUMENTS.get('bits', platform.architecture()[0])
print('Host: ' + sysname + ' ' + machine + ' ' + bits)

x86 = any(arch in machine for arch in [ 'x86', 'amd64', 'i686', 'i386', 'i86pc' ])

if bits == '32bit':
    bits = 32
elif bits == '64bit':
    bits = 64

#
# Print Help
#

Help('''
Build targets:  build tests check install all
Default target: all

Commandline Options:
    debug=n             debug build with optimization level n
    build_dir=dir       build directory, default: '.'
    boost=[0|1]         disable or enable boost libraries
    system_asio=[0|1]   use system asio library, if available
    boost_pool=[0|1]    use or not use boost pool allocator
    revno=XXXX          source code revision number
    bpostatic=path      a path to static libboost_program_options.a
    extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
    bits=[32bit|64bit]
''')
# bpostatic option added on Percona request

#
# Default params
#

build_target = 'all'

# Optimization level
opt_flags    = ' -g -O3 -DNDEBUG'

# Architecture (defaults to build host type)
compile_arch = ''
link_arch    = ''

# Build directory
build_dir    = ''


#
# Read commandline options
#

build_dir = ARGUMENTS.get('build_dir', '')

# Debug/dbug flags
debug = ARGUMENTS.get('debug', -1)
dbug  = ARGUMENTS.get('dbug', False)

debug_lvl = int(debug)
if debug_lvl >= 0 and debug_lvl < 3:
    opt_flags = ' -g -O%d -fno-inline' % debug_lvl
    dbug = True
elif debug_lvl == 3:
    opt_flags = ' -g -O3'

if dbug:
    opt_flags = opt_flags + ' -DGU_DBUG_ON'

if sysname == 'sunos':
    compile_arch = ' -mtune=native'
elif x86:
    if bits == 32:
        if machine == 'x86_64':
            compile_arch = ' -mx32'
        else:
            compile_arch = ' -m32 -march=i686'
            if sysname == 'linux':
                link_arch = ' -Wl,-melf_i386'
    else:
        compile_arch = ' -m64'
        if sysname == 'linux':
            link_arch = ' -Wl,-melf_x86_64'
    link_arch = compile_arch + link_arch
elif machine == 's390x':
    compile_arch = ' -mzarch'
    if bits == 32:
        compile_arch += ' -m32'

boost      = int(ARGUMENTS.get('boost', 1))
boost_pool = int(ARGUMENTS.get('boost_pool', 0))
system_asio= int(ARGUMENTS.get('system_asio', 1))
tests      = int(ARGUMENTS.get('tests', 1))
deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))


GALERA_VER = ARGUMENTS.get('version', '3.23')
GALERA_REV = ARGUMENTS.get('revno', 'XXXX')

# Attempt to read from file if not given
if GALERA_REV == "XXXX" and os.path.isfile("GALERA_REVISION"):
    with open("GALERA_REVISION", "r") as f:
        GALERA_REV = f.readline().rstrip("\n")

# export to any module that might have use of those
Export('GALERA_VER', 'GALERA_REV')
print('Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV)

LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '')
LIBBOOST_SYSTEM_A = string.replace(LIBBOOST_PROGRAM_OPTIONS_A, 'boost_program_options', 'boost_system')

#
# Set up and export default build environment
#

env = Environment(ENV = {'PATH' : os.environ['PATH'], 'HOME' : os.environ['HOME']})

# Set up environment for ccache and distcc
#env['ENV']['HOME']          = os.environ['HOME']
#env['ENV']['DISTCC_HOSTS']  = os.environ['DISTCC_HOSTS']
#env['ENV']['CCACHE_PREFIX'] = os.environ['CCACHE_PREFIX']
if 'CCACHE_DIR' in os.environ:
    env['ENV']['CCACHE_DIR'] = os.environ['CCACHE_DIR']
if 'CCACHE_CPP2' in os.environ:
    env['ENV']['CCACHE_CPP2'] = os.environ['CCACHE_CPP2']

# Set CC and CXX compilers
cc = os.getenv('CC', 'default')
if cc != 'default':
    env.Replace(CC = cc)
cxx = os.getenv('CXX', 'default')
if cxx != 'default':
    env.Replace(CXX = cxx)
link = os.getenv('LINK', 'default')
if link != 'default':
    env.Replace(LINK = link)

# Get compiler name/version, CXX may be set to "c++" which may be clang or gcc
cc_version = read_first_line(env['CC'].split() + ['--version'])
cxx_version = read_first_line(env['CXX'].split() + ['--version'])

print('Using C compiler executable: ' + env['CC'])
print('C compiler version is: ' + cc_version)
print('Using C++ compiler executable: ' + env['CXX'])
print('C++ compiler version is: ' + cxx_version)

# Initialize CPPFLAGS and LIBPATH from environment to get user preferences
env.Replace(CPPFLAGS  = os.getenv('CPPFLAGS', ''))
env.Replace(CCFLAGS   = os.getenv('CCFLAGS',  opt_flags + compile_arch))
env.Replace(CFLAGS    = os.getenv('CFLAGS',   ''))
env.Replace(CXXFLAGS  = os.getenv('CXXFLAGS', ''))
env.Replace(LINKFLAGS = os.getenv('LDFLAGS',  link_arch))
env.Replace(LIBPATH   = [os.getenv('LIBPATH', '')])
env.Replace(RPATH     = [os.getenv('RPATH',   '')])

# Set -pthread flag explicitly to make sure that pthreads are
# enabled on all platforms.
env.Append(CCFLAGS = ' -pthread')

# FreeBSD ports are usually installed under /usr/local
if sysname == 'freebsd' or sysname == 'sunos':
    env.Append(LIBPATH = ['/usr/local/lib'])
    env.Append(CPPPATH = ['/usr/local/include'])
if sysname == 'sunos':
   env.Replace(SHLINKFLAGS = '-shared ')

# Add paths is extra_sysroot argument was specified
extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
if sysname == 'darwin' and extra_sysroot == '':
    # common developer environments and paths
    if os.system('which -s port') == 0 and os.path.isfile('/opt/local/bin/port'):
        extra_sysroot = '/opt/local'
    elif os.system('which -s brew') == 0 and os.path.isfile('/usr/local/bin/brew'):
        extra_sysroot = '/usr/local'
    elif os.system('which -s fink') == 0 and os.path.isfile('/sw/bin/fink'):
        extra_sysroot = '/sw'
if extra_sysroot != '':
    env.Append(LIBPATH = [extra_sysroot + '/lib'])
    env.Append(CPPFLAGS = ' -I' + extra_sysroot + '/include')

# print env.Dump()

# Preprocessor flags
if sysname != 'sunos' and sysname != 'darwin' and sysname != 'freebsd':
    env.Append(CPPFLAGS = ' -D_XOPEN_SOURCE=600')
if sysname == 'sunos':
    env.Append(CPPFLAGS = ' -D__EXTENSIONS__')
env.Append(CPPFLAGS = ' -DHAVE_COMMON_H')

# Common C/CXX flags
# These should be kept minimal as they are appended after C/CXX specific flags
env.Append(CCFLAGS = ' -fPIC -Wall -Wextra -Wno-unused-parameter')

# C-specific flags
env.Prepend(CFLAGS = '-std=c99 -fno-strict-aliasing -pipe ')

# CXX-specific flags
# Note: not all 3rd-party libs like '-Wold-style-cast -Weffc++'
#       adding those after checks
env.Prepend(CXXFLAGS = '-Wno-long-long -Wno-deprecated -ansi ')
if sysname != 'sunos':
    env.Prepend(CXXFLAGS = '-pipe ')


# Linker flags
# TODO: enable ' -Wl,--warn-common -Wl,--fatal-warnings' after warnings from
# static linking have beed addressed
#
#env.Prepend(LINKFLAGS = '-Wl,--warn-common -Wl,--fatal-warnings ')

#
# Check required headers and libraries (autoconf functionality)
#

#
# Custom tests:
#

def CheckCpp11(context):
    test_source = """
#if __cplusplus < 201103
#error Not compiling in C++11 mode
#endif
int main() { return 0; }
"""
    context.Message('Checking if compiling in C++11 mode ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckSystemASIOVersion(context):
    system_asio_test_source_file = """
#include <asio.hpp>

#if ASIO_VERSION < 101001
#error "Included asio version is too old"
#endif

int main()
{
    return 0;
}

"""
    context.Message('Checking ASIO version (> 1.10.1) ... ')
    result = context.TryLink(system_asio_test_source_file, '.cpp')
    context.Result(result)
    return result

def CheckTr1Array(context):
    test_source = """
#include <tr1/array>
int main() { std::tr1::array<int, 5> a; return 0; }
"""
    context.Message('Checking for std::tr1::array ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckTr1SharedPtr(context):
    test_source = """
#include <tr1/memory>
int main() { int n; std::tr1::shared_ptr<int> p(&n); return 0; }
"""
    context.Message('Checking for std::tr1::shared_ptr ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckTr1UnorderedMap(context):
    test_source = """
#include <tr1/unordered_map>
int main() { std::tr1::unordered_map<int, int> m; return 0; }
"""
    context.Message('Checking for std::tr1::unordered_map ... ')
    result = context.TryLink(test_source, '.cpp')
    context.Result(result)
    return result

def CheckWeffcpp(context):
    # Some compilers (gcc <= 4.8 at least) produce a bogus warning for the code
    # below when -Weffc++ is used.
    test_source = """
class A {};
class B : public A {};
int main() { return 0; }
"""
    context.Message('Checking whether to enable -Weffc++ ... ')
    cxxflags_orig = context.env['CXXFLAGS']
    context.env.Prepend(CXXFLAGS = '-Weffc++ -Werror ')
    result = context.TryLink(test_source, '.cpp')
    context.env.Replace(CXXFLAGS = cxxflags_orig)
    context.Result(result)
    return result

#
# Construct configuration context
#
conf = Configure(env, custom_tests = {
    'CheckCpp11': CheckCpp11,
    'CheckSystemASIOVersion': CheckSystemASIOVersion,
    'CheckTr1Array': CheckTr1Array,
    'CheckTr1SharedPtr': CheckTr1SharedPtr,
    'CheckTr1UnorderedMap': CheckTr1UnorderedMap,
    'CheckWeffcpp': CheckWeffcpp
})

# System headers and libraries

if not conf.CheckLib('pthread'):
    print('Error: pthread library not found')
    Exit(1)

# libatomic may be needed on some 32bit platforms (and 32bit userland PPC64)
# for 8 byte atomics but not generally required
if not x86:
    conf.CheckLib('atomic')

if sysname != 'darwin':
    if not conf.CheckLib('rt'):
        print('Error: rt library not found')
        Exit(1)

if sysname == 'freebsd':
    if not conf.CheckLib('execinfo'):
        print('Error: execinfo library not found')
        Exit(1)

if sysname == 'sunos':
    if not conf.CheckLib('socket'):
        print('Error: socket library not found')
        Exit(1)
    if not conf.CheckLib('crypto'):
        print('Error: crypto library not found')
        Exit(1)
    if not conf.CheckLib('nsl'):
        print('Error: nsl library not found')
        Exit(1)

if conf.CheckHeader('sys/epoll.h'):
    conf.env.Append(CPPFLAGS = ' -DGALERA_USE_GU_NETWORK')

if conf.CheckHeader('byteswap.h'):
    conf.env.Append(CPPFLAGS = ' -DHAVE_BYTESWAP_H')

if conf.CheckHeader('endian.h'):

=== debian/changelog ===
galera-3 (25.3.23-1ubuntu1) cosmic; urgency=medium

  * Do not run testsuite on armhf with arm64 kernel due to bus errors.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 20 Jul 2018 11:10:09 +0100

galera-3 (25.3.23-1build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 13:13:24 +0000

galera-3 (25.3.23-1) unstable; urgency=low

  * Update VCS-* links to point to Salsa
  * New upstream version 25.3.23
    - Includes GCC-7 build fix (Closes: #853410)
  * Fix Lintian complaints
  * Use dh --list-missing to detect extra files that might belong in package

 -- Otto Kekäläinen <otto@debian.org>  Sun, 04 Mar 2018 01:12:52 +0200

=== debian/control ===
Source: galera-3
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Otto Kekäläinen <otto@debian.org>
Section: database
Priority: extra
Standards-Version: 4.1.3.0
Build-Depends: check,
               debhelper (>= 9),
               libasio-dev,
               libboost-dev (>= 1.41),
               libboost-program-options-dev (>= 1.41),
               libssl-dev,
               scons (>= 2)
Homepage: http://www.galeracluster.com/
Vcs-Browser: https://salsa.debian.org/mariadb-team/galera-3
Vcs-Git: https://salsa.debian.org/mariadb-team/galera-3.git

Package: galera-3
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Conflicts: garbd-2,
           garbd2,
           percona-galera-3,
           percona-xtradb-cluster-galera,
           percona-xtradb-cluster-galera-2.x,
           percona-xtradb-cluster-galera-3.x,
           percona-xtradb-cluster-garbd-2.x,
           percona-xtradb-cluster-garbd-3.x
Provides: galera, galera3, percona-xtradb-cluster-galera-25, wsrep
Breaks: galera
Replaces: galera
Description: Replication framework for transactional applications
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see http://launchpad.net/wsrep. For a description of Galera
 replication engine see http://galeracluster.com.
 .
 This package contains the Galera library/plugin.

Package: galera-3-dbg
Architecture: any
Section: debug
Depends: galera-3 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for galera-3
 This package contains the debugging symbols for galera-3.

Package: galera-arbitrator-3
Architecture: any
Conflicts: garbd-2, garbd2, percona-xtradb-cluster-garbd-2.x
Breaks: percona-xtradb-cluster-galera-2.x
Replaces: percona-xtradb-cluster-galera-2.x
Depends: lsb-base (>= 3.0-6), ${misc:Depends}, ${shlibs:Depends}
Description: Galera arbitrator daemon
 Galera is a fast synchronous multimaster wsrep provider (replication engine)
 for transactional databases and similar applications. For more information
 about wsrep API see http://launchpad.net/wsrep. For a description of Galera
 replication engine see http://galeracluster.com.
 .
 This package contains the Galera arbitrator daemon (garbd).

Package: galera-arbitrator-3-dbg
Architecture: any
Section: debug
Conflicts: percona-xtradb-cluster-galera-2.x-dbg
Depends: galera-arbitrator-3 (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for galera-arbitrator-3
 This package contains the debugging symbols for galera-arbitrator-3.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# Parallel build support as adviced
# at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += -j$(NUMJOBS)
	# Don't use MAKEFLAGS as it has strange 'w' and '--jobserver-fds=3,4' by default
endif

# Add support for verbose builds
ifneq (,$(filter verbose,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += VERBOSE=1
endif

# Run tests by default
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
# Bus errors on arm64 kernels prevent running testsuite when building armhf
ifeq (armhf,$(DEB_HOST_ARCH))
	SCONS_ARGS += tests=0 deterministic_tests=0
else
	SCONS_ARGS += tests=1 deterministic_tests=1
endif
endif

# Use strict compilation flags (ie -Werror) if requested
ifneq (,$(filter strict_build_flags,$(DEB_BUILD_OPTIONS)))
	SCONS_ARGS += strict_build_flags=1
endif


override_dh_auto_build:
	# Print build env info to help debug builds on different platforms
	dpkg-architecture
	@echo $(SCONS_ARGS)
	scons $(SCONS_ARGS) || touch FAIL # Print config.log if build fails
	@echo '*****************************************'
	@echo '**  config.log contents for debugging  **'
	@echo '*****************************************'
	@cat config.log
	@echo '*****************************************'
	if [ -f FAIL ]; then exit 1; fi

# Start earlier than MySQL which has value 19
override_dh_installinit-arch:
	dh_installinit -n --name=garb -- defaults 18 22

override_dh_strip:
	dh_strip -pgalera-3 --dbg-package=galera-3-dbg
	dh_strip -pgalera-arbitrator-3 --dbg-package=galera-arbitrator-3-dbg

%:
	dh $@ --list-missing

.PHONY: override_dh_strip

## galera-3 25.3.24

=== SConstruct ===
--- 
+++ 
@@ -141,7 +141,7 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.23')
+GALERA_VER = ARGUMENTS.get('version', '3.24')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -154,7 +154,7 @@
 print('Signature: version: ' + GALERA_VER + ', revision: ' + GALERA_REV)
 
 LIBBOOST_PROGRAM_OPTIONS_A = ARGUMENTS.get('bpostatic', '')
-LIBBOOST_SYSTEM_A = string.replace(LIBBOOST_PROGRAM_OPTIONS_A, 'boost_program_options', 'boost_system')
+LIBBOOST_SYSTEM_A = LIBBOOST_PROGRAM_OPTIONS_A.replace('boost_program_options', 'boost_system')
 
 #
 # Set up and export default build environment
@@ -183,8 +183,8 @@
     env.Replace(LINK = link)
 
 # Get compiler name/version, CXX may be set to "c++" which may be clang or gcc
-cc_version = read_first_line(env['CC'].split() + ['--version'])
-cxx_version = read_first_line(env['CXX'].split() + ['--version'])
+cc_version = str(read_first_line(env['CC'].split() + ['--version']))
+cxx_version = str(read_first_line(env['CXX'].split() + ['--version']))
 
 print('Using C compiler executable: ' + env['CC'])
 print('C compiler version is: ' + cc_version)
@@ -340,6 +340,17 @@
     context.Result(result)
     return result
 
+# advanced SSL features
+def CheckSetEcdhAuto(context):
+    test_source = """
+#include <openssl/ssl.h>
+int main() { SSL_CTX* ctx=NULL; return !SSL_CTX_set_ecdh_auto(ctx, 1); }
+"""
+    context.Message('Checking for SSL_CTX_set_ecdh_auto() ... ')
+    result = context.TryLink(test_source, '.cpp')
+    context.Result(result)
+    return result
+
 #
 # Construct configuration context
 #
@@ -349,8 +360,11 @@
     'CheckTr1Array': CheckTr1Array,
     'CheckTr1SharedPtr': CheckTr1SharedPtr,
     'CheckTr1UnorderedMap': CheckTr1UnorderedMap,
-    'CheckWeffcpp': CheckWeffcpp
+    'CheckWeffcpp': CheckWeffcpp,
+    'CheckSetEcdhAuto': CheckSetEcdhAuto
 })
+
+conf.env.Append(CPPPATH = [ '#/wsrep/src' ])
 
 # System headers and libraries
 
@@ -376,18 +390,3 @@
 if sysname == 'sunos':
     if not conf.CheckLib('socket'):
         print('Error: socket library not found')
-        Exit(1)
-    if not conf.CheckLib('crypto'):
-        print('Error: crypto library not found')
-        Exit(1)
-    if not conf.CheckLib('nsl'):
-        print('Error: nsl library not found')
-        Exit(1)
-
-if conf.CheckHeader('sys/epoll.h'):
-    conf.env.Append(CPPFLAGS = ' -DGALERA_USE_GU_NETWORK')
-
-if conf.CheckHeader('byteswap.h'):
-    conf.env.Append(CPPFLAGS = ' -DHAVE_BYTESWAP_H')
-
-if conf.CheckHeader('endian.h'):

## galera-3 25.3.25

=== SConstruct ===
--- 
+++ 
@@ -141,7 +141,7 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.24')
+GALERA_VER = ARGUMENTS.get('version', '3.25')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -279,8 +279,13 @@
     system_asio_test_source_file = """
 #include <asio.hpp>
 
+#define XSTR(x) STR(x)
+#define STR(x) #x
+#pragma message "Asio version:" XSTR(ASIO_VERSION)
 #if ASIO_VERSION < 101001
-#error "Included asio version is too old"
+#error Included asio version is too old
+#elif ASIO_VERSION >= 101100
+#error Included asio version is too new
 #endif
 
 int main()
@@ -289,7 +294,7 @@
 }
 
 """
-    context.Message('Checking ASIO version (> 1.10.1) ... ')
+    context.Message('Checking ASIO version (>= 1.10.1 and < 1.11.0) ... ')
     result = context.TryLink(system_asio_test_source_file, '.cpp')
     context.Result(result)
     return result
@@ -347,6 +352,16 @@
 int main() { SSL_CTX* ctx=NULL; return !SSL_CTX_set_ecdh_auto(ctx, 1); }
 """
     context.Message('Checking for SSL_CTX_set_ecdh_auto() ... ')
+    result = context.TryLink(test_source, '.cpp')
+    context.Result(result)
+    return result
+
+def CheckSetTmpEcdh(context):
+    test_source = """
+#include <openssl/ssl.h>
+int main() { SSL_CTX* ctx=NULL; EC_KEY* ecdh=NULL; return !SSL_CTX_set_tmp_ecdh(ctx,ecdh); }
+"""
+    context.Message('Checking for SSL_CTX_set_tmp_ecdh_() ... ')
     result = context.TryLink(test_source, '.cpp')
     context.Result(result)
     return result
@@ -361,7 +376,8 @@
     'CheckTr1SharedPtr': CheckTr1SharedPtr,
     'CheckTr1UnorderedMap': CheckTr1UnorderedMap,
     'CheckWeffcpp': CheckWeffcpp,
-    'CheckSetEcdhAuto': CheckSetEcdhAuto
+    'CheckSetEcdhAuto': CheckSetEcdhAuto,
+    'CheckSetTmpEcdh': CheckSetTmpEcdh
 })
 
 conf.env.Append(CPPPATH = [ '#/wsrep/src' ])
@@ -369,24 +385,3 @@
 # System headers and libraries
 
 if not conf.CheckLib('pthread'):
-    print('Error: pthread library not found')
-    Exit(1)
-
-# libatomic may be needed on some 32bit platforms (and 32bit userland PPC64)
-# for 8 byte atomics but not generally required
-if not x86:
-    conf.CheckLib('atomic')
-
-if sysname != 'darwin':
-    if not conf.CheckLib('rt'):
-        print('Error: rt library not found')
-        Exit(1)
-
-if sysname == 'freebsd':
-    if not conf.CheckLib('execinfo'):
-        print('Error: execinfo library not found')
-        Exit(1)
-
-if sysname == 'sunos':
-    if not conf.CheckLib('socket'):
-        print('Error: socket library not found')

=== debian/changelog ===
galera-3 (25.3.25-2) unstable; urgency=low

  [ Giovanni Mascellani ]
  * Hopefully fix FTBFS on mipsel (Closes: #920209)

 -- Otto Kekäläinen <otto@debian.org>  Sat, 30 Mar 2019 16:22:23 +0200

galera-3 (25.3.25-1) unstable; urgency=low

  [ Otto Kekäläinen ]
  * New upstream version 25.3.25

  [ Logan Rosen ]
  * Fix FTBFS against system asio by using bundled version instead
    (Closes: #914112)

  [ Samuel Thibault ]
  * Fix FTBFS on hurd-i386 (Closes: #906305)
  * Do not assume timestamps are strictly monotonous (Closes: #856237)
  * Fix FTBFS on kfreebsd (Closes: #906081)

 -- Otto Kekäläinen <otto@debian.org>  Wed, 09 Jan 2019 00:39:48 +0100

galera-3 (25.3.24-1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * New upstream version 25.3.24
  * Add .gitlab-ci.yml copied from Salsa-CI team's example
  * Add rudimentary autopkgtests
  * Make build reproducible by forcing an empty GNU build-id
  * Explicitly forbid tests if DEB_BUILD_OPTIONS has nocheck
  * Add d/upstream/metadata file
  * Update http -> https addresses where available
  * Add 'terse' support in DEB_BUILD_OPTIONS
  * Replace buildflags.mk with full default.mk dpkg settings
  * Drop usage of _SYSTEMCTL_SKIP_REDIRECT from init script (Closes: #910471)
  * Debian Policy 4.0.1: use priority 'optional' instead of 'extra'

  [ Dimitri John Ledkov ]
  * Do not run testsuite on armhf with arm64 kernel due to bus errors

  [ Daniel Kahn Gillmor ]
  * Modernize debugging symbols

 -- Otto Kekäläinen <otto@debian.org>  Mon, 15 Oct 2018 16:24:30 +0300

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,11 @@
 Source: galera-3
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
+Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
 Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
-Priority: extra
-Standards-Version: 4.1.3.0
+Priority: optional
+Standards-Version: 4.2.1
 Build-Depends: check,
-               debhelper (>= 9),
-               libasio-dev,
+               debhelper (>= 9.20151219~),
                libboost-dev (>= 1.41),
                libboost-program-options-dev (>= 1.41),
                libssl-dev,
@@ -34,17 +32,10 @@
 Description: Replication framework for transactional applications
  Galera is a fast synchronous multimaster wsrep provider (replication engine)
  for transactional databases and similar applications. For more information
- about wsrep API see http://launchpad.net/wsrep. For a description of Galera
+ about wsrep API see https://launchpad.net/wsrep. For a description of Galera
  replication engine see http://galeracluster.com.
  .
  This package contains the Galera library/plugin.
-
-Package: galera-3-dbg
-Architecture: any
-Section: debug
-Depends: galera-3 (= ${binary:Version}), ${misc:Depends}
-Description: debugging symbols for galera-3
- This package contains the debugging symbols for galera-3.
 
 Package: galera-arbitrator-3
 Architecture: any
@@ -59,11 +50,3 @@
  replication engine see http://galeracluster.com.
  .
  This package contains the Galera arbitrator daemon (garbd).
-
-Package: galera-arbitrator-3-dbg
-Architecture: any
-Section: debug
-Conflicts: percona-xtradb-cluster-galera-2.x-dbg
-Depends: galera-arbitrator-3 (= ${binary:Version}), ${misc:Depends}
-Description: debugging symbols for galera-arbitrator-3
- This package contains the debugging symbols for galera-arbitrator-3.

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,10 @@
 #!/usr/bin/make -f
-
-export DH_VERBOSE=1
 export DEB_BUILD_HARDENING=1
 DPKG_EXPORT_BUILDFLAGS = 1
 include /usr/share/dpkg/default.mk
+
+# Use bundled asio, since system asio is too new (> 1.10.8)
+SCONS_ARGS += system_asio=0
 
 # Parallel build support as adviced
 # at https://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
@@ -13,12 +14,14 @@
 	# Don't use MAKEFLAGS as it has strange 'w' and '--jobserver-fds=3,4' by default
 endif
 
-# Add support for verbose builds
-ifneq (,$(filter verbose,$(DEB_BUILD_OPTIONS)))
+# According to Debian Policy version 4.2.0 builds should be as verbose as
+# possible unless 'terse' is specifically passed.
+ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
 	SCONS_ARGS += VERBOSE=1
+	export DH_VERBOSE=1
 endif
 
-# Run tests by default
+# Tests are run by default sometimes, so explicitly enable or disable them
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 # Bus errors on arm64 kernels prevent running testsuite when building armhf
 ifeq (armhf,$(DEB_HOST_ARCH))
@@ -26,11 +29,19 @@
 else
 	SCONS_ARGS += tests=1 deterministic_tests=1
 endif
+else
+	SCONS_ARGS += tests=0 deterministic_tests=0
 endif
 
 # Use strict compilation flags (ie -Werror) if requested
 ifneq (,$(filter strict_build_flags,$(DEB_BUILD_OPTIONS)))
 	SCONS_ARGS += strict_build_flags=1
+endif
+
+# Some mipsel buildd's are a bit slow and fail tests if they are not
+# given enough time
+ifeq (mipsel,$(DEB_HOST_ARCH))
+        export CK_TIMEOUT_MULTIPLIER=2
 endif
 
 
@@ -51,8 +62,7 @@
 	dh_installinit -n --name=garb -- defaults 18 22
 
 override_dh_strip:
-	dh_strip -pgalera-3 --dbg-package=galera-3-dbg
-	dh_strip -pgalera-arbitrator-3 --dbg-package=galera-arbitrator-3-dbg
+	dh_strip --dbgsym-migration='galera-3-dbg (<< 25.3.23-2~), galera-arbitrator-3-dbg (<< 25.3.23-2~)'
 
 %:
 	dh $@ --list-missing

=== debian/tests/control ===
Tests: smoke
Depends: galera-arbitrator-3
Restrictions: allow-stderr

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
  http://releases.galeracluster.com/galera-3/source/galera-3-(.+).tar.gz

## galera-3 25.3.26

=== SConstruct ===
--- 
+++ 
@@ -141,7 +141,7 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.25')
+GALERA_VER = ARGUMENTS.get('version', '3.26')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -210,6 +210,11 @@
     env.Append(CPPPATH = ['/usr/local/include'])
 if sysname == 'sunos':
    env.Replace(SHLINKFLAGS = '-shared ')
+
+# Build shared objects with dynamic symbol dispatching disabled.
+# This enables predictable behavior upon dynamic loading with programs
+# that have own versions of commonly used libraries linked in (boost, asio, etc.)
+env.Append(SHLINKFLAGS = ' -Wl,-Bsymbolic -Wl,-Bsymbolic-functions')
 
 # Add paths is extra_sysroot argument was specified
 extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
@@ -282,7 +287,7 @@
 #define XSTR(x) STR(x)
 #define STR(x) #x
 #pragma message "Asio version:" XSTR(ASIO_VERSION)
-#if ASIO_VERSION < 101001
+#if ASIO_VERSION < 101008
 #error Included asio version is too old
 #elif ASIO_VERSION >= 101100
 #error Included asio version is too new
@@ -294,7 +299,7 @@
 }
 
 """
-    context.Message('Checking ASIO version (>= 1.10.1 and < 1.11.0) ... ')
+    context.Message('Checking ASIO version (>= 1.10.8 and < 1.11.0) ... ')
     result = context.TryLink(system_asio_test_source_file, '.cpp')
     context.Result(result)
     return result
@@ -374,14 +379,3 @@
     'CheckSystemASIOVersion': CheckSystemASIOVersion,
     'CheckTr1Array': CheckTr1Array,
     'CheckTr1SharedPtr': CheckTr1SharedPtr,
-    'CheckTr1UnorderedMap': CheckTr1UnorderedMap,
-    'CheckWeffcpp': CheckWeffcpp,
-    'CheckSetEcdhAuto': CheckSetEcdhAuto,
-    'CheckSetTmpEcdh': CheckSetTmpEcdh
-})
-
-conf.env.Append(CPPPATH = [ '#/wsrep/src' ])
-
-# System headers and libraries
-
-if not conf.CheckLib('pthread'):

=== debian/changelog ===
galera-3 (25.3.26-1) unstable; urgency=medium

  * New upstream version 25.3.26

 -- Otto Kekäläinen <otto@debian.org>  Tue, 23 Apr 2019 13:23:35 +0300

## galera-3 25.3.27

=== SConstruct ===
--- 
+++ 
@@ -91,6 +91,16 @@
 
 # Build directory
 build_dir    = ''
+
+# Version script file
+galera_script = File('#/galera-sym.map').abspath
+with open(galera_script, 'w') as f:
+    f.write('''{
+    global: wsrep_loader;
+            wsrep_interface_version;
+    local:  *;
+};
+''')
 
 
 #
@@ -141,7 +151,7 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.26')
+GALERA_VER = ARGUMENTS.get('version', '3.27')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -210,11 +220,6 @@
     env.Append(CPPPATH = ['/usr/local/include'])
 if sysname == 'sunos':
    env.Replace(SHLINKFLAGS = '-shared ')
-
-# Build shared objects with dynamic symbol dispatching disabled.
-# This enables predictable behavior upon dynamic loading with programs
-# that have own versions of commonly used libraries linked in (boost, asio, etc.)
-env.Append(SHLINKFLAGS = ' -Wl,-Bsymbolic -Wl,-Bsymbolic-functions')
 
 # Add paths is extra_sysroot argument was specified
 extra_sysroot = ARGUMENTS.get('extra_sysroot', '')
@@ -371,11 +376,16 @@
     context.Result(result)
     return result
 
+def CheckVersionScript(context):
+    test_source = """
+int main() { return 0; }
+"""
+    context.Message('Checking for --version-script linker option ... ')
+    result = context.TryLink(test_source, '.cpp')
+    context.Result(result)
+    return result
+
 #
 # Construct configuration context
 #
 conf = Configure(env, custom_tests = {
-    'CheckCpp11': CheckCpp11,
-    'CheckSystemASIOVersion': CheckSystemASIOVersion,
-    'CheckTr1Array': CheckTr1Array,
-    'CheckTr1SharedPtr': CheckTr1SharedPtr,

=== debian/changelog ===
galera-3 (25.3.27-1) unstable; urgency=medium

  * New upstream version 25.3.27
  * Include full CC-BY-SA-3.0 license in debian/copyright to satisfy Lintian
  * Drop manual dbgsym creation as this is nowadays automatic
  * Apply upstream patch for FTBFS on hppa, hurd and kfreebsd-*
    (Closes: #927846)

 -- Otto Kekäläinen <otto@debian.org>  Sat, 27 Jul 2019 16:33:43 -0300

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
 Priority: optional
-Standards-Version: 4.2.1
+Standards-Version: 4.4.0
 Build-Depends: check,
                debhelper (>= 9.20151219~),
                libboost-dev (>= 1.41),

=== debian/rules ===
--- 
+++ 
@@ -44,7 +44,6 @@
         export CK_TIMEOUT_MULTIPLIER=2
 endif
 
-
 override_dh_auto_build:
 	# Print build env info to help debug builds on different platforms
 	dpkg-architecture
@@ -61,10 +60,5 @@
 override_dh_installinit-arch:
 	dh_installinit -n --name=garb -- defaults 18 22
 
-override_dh_strip:
-	dh_strip --dbgsym-migration='galera-3-dbg (<< 25.3.23-2~), galera-arbitrator-3-dbg (<< 25.3.23-2~)'
-
 %:
 	dh $@ --list-missing
-
-.PHONY: override_dh_strip

## galera-3 25.3.28

=== SConstruct ===
--- 
+++ 
@@ -151,7 +151,7 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.27')
+GALERA_VER = ARGUMENTS.get('version', '3.28')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given

=== debian/changelog ===
galera-3 (25.3.28-2build1) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:26:32 +0000

galera-3 (25.3.28-2) unstable; urgency=low

  [ Debian Janitor ]
  * Use secure URI in debian/watch.
  * Update standards version to 4.4.1, no changes needed.
  * Bump debhelper from old 9 to 12.
  * Fix field name typos in debian/copyright.
  * Remove obsolete fields Name, Contact from debian/upstream/metadata.

 -- Otto Kekäläinen <otto@debian.org>  Mon, 16 Dec 2019 21:32:17 +0200

galera-3 (25.3.28-1) unstable; urgency=medium

  * New upstream version 25.3.28 (Closes: #940200)
  * Remove patch for #927846 as it was applied upstream.
  * Mark autopkgtests with new 'superficial' as it applies to this package

 -- Otto Kekäläinen <otto@debian.org>  Mon, 16 Sep 2019 19:17:31 +0300

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,12 @@
 Source: galera-3
-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
 Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
 Priority: optional
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Build-Depends: check,
-               debhelper (>= 9.20151219~),
+               debhelper-compat (= 12),
                libboost-dev (>= 1.41),
                libboost-program-options-dev (>= 1.41),
                libssl-dev,

## galera-3 25.3.29

=== SConstruct ===
--- 
+++ 
@@ -147,11 +147,14 @@
 boost_pool = int(ARGUMENTS.get('boost_pool', 0))
 system_asio= int(ARGUMENTS.get('system_asio', 1))
 tests      = int(ARGUMENTS.get('tests', 1))
+# Run only tests which are known to be deterministic
 deterministic_tests = int(ARGUMENTS.get('deterministic_tests', 0))
+# Run all tests
+all_tests = int(ARGUMENTS.get('all_tests', 0))
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
 
 
-GALERA_VER = ARGUMENTS.get('version', '3.28')
+GALERA_VER = ARGUMENTS.get('version', '3.29')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -382,10 +385,3 @@
 """
     context.Message('Checking for --version-script linker option ... ')
     result = context.TryLink(test_source, '.cpp')
-    context.Result(result)
-    return result
-
-#
-# Construct configuration context
-#
-conf = Configure(env, custom_tests = {

=== debian/changelog ===
galera-3 (25.3.29-1) unstable; urgency=medium

  * New upstream version 25.3.29

 -- Otto Kekäläinen <otto@debian.org>  Tue, 11 Feb 2020 15:35:02 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: galera-3
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
+Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
 Uploaders: Otto Kekäläinen <otto@debian.org>
 Section: database
 Priority: optional

=== debian/rules ===
--- 
+++ 
@@ -61,4 +61,4 @@
 	dh_installinit -n --name=garb -- defaults 18 22
 
 %:
-	dh $@ --list-missing
+	dh $@

=== debian/tests/control ===
Tests: smoke
Depends: galera-arbitrator-3
Restrictions: allow-stderr superficial

## galera-3 25.3.30

=== SConstruct ===
--- 
+++ 
@@ -1,6 +1,6 @@
 ###################################################################
 #
-# Copyright (C) 2010-2017 Codership Oy <info@codership.com>
+# Copyright (C) 2010-2020 Codership Oy <info@codership.com>
 #
 # SCons build script to build galera libraries
 #
@@ -71,8 +71,10 @@
     boost_pool=[0|1]    use or not use boost pool allocator
     revno=XXXX          source code revision number
     bpostatic=path      a path to static libboost_program_options.a
+    static_ssl=path     a path to static SSL libraries
     extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
     bits=[32bit|64bit]
+    install=path        install files under path
 ''')
 # bpostatic option added on Percona request
 
@@ -152,9 +154,10 @@
 # Run all tests
 all_tests = int(ARGUMENTS.get('all_tests', 0))
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
-
-
-GALERA_VER = ARGUMENTS.get('version', '3.29')
+static_ssl = ARGUMENTS.get('static_ssl', None)
+install = ARGUMENTS.get('install', None)
+
+GALERA_VER = ARGUMENTS.get('version', '3.30')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -380,8 +383,3 @@
     return result
 
 def CheckVersionScript(context):
-    test_source = """
-int main() { return 0; }
-"""
-    context.Message('Checking for --version-script linker option ... ')
-    result = context.TryLink(test_source, '.cpp')

=== debian/changelog ===
galera-3 (25.3.30-1) unstable; urgency=medium

  * New upstream version 25.3.30
  * Reduce the runtime overhead for may EVS tests so armel builds can
    pass again (Closes: #958040)
  * Fix typo in original source code
  * Apply same d/rules hardening flags as done in galera-4

 -- Otto Kekäläinen <otto@debian.org>  Sun, 28 Jun 2020 15:46:33 +0300

galera-3 (25.3.29-2) unstable; urgency=medium

  * New source-only upload so package can enter Debian testing

 -- Otto Kekäläinen <otto@debian.org>  Sun, 23 Feb 2020 10:40:54 +0200

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,8 @@
 Package: galera-3
 Architecture: any
 Section: libs
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Conflicts: garbd-2,
            garbd2,
            percona-galera-3,
@@ -26,7 +27,10 @@
            percona-xtradb-cluster-galera-3.x,
            percona-xtradb-cluster-garbd-2.x,
            percona-xtradb-cluster-garbd-3.x
-Provides: galera, galera3, percona-xtradb-cluster-galera-25, wsrep
+Provides: galera,
+          galera3,
+          percona-xtradb-cluster-galera-25,
+          wsrep
 Breaks: galera
 Replaces: galera
 Description: Replication framework for transactional applications
@@ -39,10 +43,14 @@
 
 Package: galera-arbitrator-3
 Architecture: any
-Conflicts: garbd-2, garbd2, percona-xtradb-cluster-garbd-2.x
+Conflicts: garbd-2,
+           garbd2,
+           percona-xtradb-cluster-garbd-2.x
 Breaks: percona-xtradb-cluster-galera-2.x
 Replaces: percona-xtradb-cluster-galera-2.x
-Depends: lsb-base (>= 3.0-6), ${misc:Depends}, ${shlibs:Depends}
+Depends: lsb-base (>= 3.0-6),
+         ${misc:Depends},
+         ${shlibs:Depends}
 Description: Galera arbitrator daemon
  Galera is a fast synchronous multimaster wsrep provider (replication engine)
  for transactional databases and similar applications. For more information

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,10 @@
 #!/usr/bin/make -f
-export DEB_BUILD_HARDENING=1
+
+# Enable Debian Hardening
+# https://wiki.debian.org/Hardening
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 DPKG_EXPORT_BUILDFLAGS = 1
+# Include all defaults, includes buildflags.mk
 include /usr/share/dpkg/default.mk
 
 # Use bundled asio, since system asio is too new (> 1.10.8)

## galera-3 25.3.31

=== SConstruct ===
--- 
+++ 
@@ -65,6 +65,7 @@
 
 Commandline Options:
     debug=n             debug build with optimization level n
+    asan=[0|1]          disable or enable ASAN instrumentation
     build_dir=dir       build directory, default: '.'
     boost=[0|1]         disable or enable boost libraries
     system_asio=[0|1]   use system asio library, if available
@@ -75,6 +76,8 @@
     extra_sysroot=path  a path to extra development environment (Fink, Homebrew, MacPorts, MinGW)
     bits=[32bit|64bit]
     install=path        install files under path
+    version_script=[0|1] Use version script (default 1)
+    crc32c_no_hardware=[0|1] disable building hardware support for CRC32C
 ''')
 # bpostatic option added on Percona request
 
@@ -114,6 +117,7 @@
 # Debug/dbug flags
 debug = ARGUMENTS.get('debug', -1)
 dbug  = ARGUMENTS.get('dbug', False)
+asan = ARGUMENTS.get('asan', 0)
 
 debug_lvl = int(debug)
 if debug_lvl >= 0 and debug_lvl < 3:
@@ -156,8 +160,9 @@
 strict_build_flags = int(ARGUMENTS.get('strict_build_flags', 0))
 static_ssl = ARGUMENTS.get('static_ssl', None)
 install = ARGUMENTS.get('install', None)
-
-GALERA_VER = ARGUMENTS.get('version', '3.30')
+version_script = int(ARGUMENTS.get('version_script', 1))
+
+GALERA_VER = ARGUMENTS.get('version', '3.31')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -271,6 +276,11 @@
 #
 #env.Prepend(LINKFLAGS = '-Wl,--warn-common -Wl,--fatal-warnings ')
 
+if int(asan):
+    env.Append(CCFLAGS = ' -fsanitize=address')
+    env.Append(CPPFLAGS = ' -DGALERA_WITH_ASAN')
+    env.Append(LINKFLAGS = ' -fsanitize=address')
+
 #
 # Check required headers and libraries (autoconf functionality)
 #
@@ -368,18 +378,3 @@
 int main() { SSL_CTX* ctx=NULL; return !SSL_CTX_set_ecdh_auto(ctx, 1); }
 """
     context.Message('Checking for SSL_CTX_set_ecdh_auto() ... ')
-    result = context.TryLink(test_source, '.cpp')
-    context.Result(result)
-    return result
-
-def CheckSetTmpEcdh(context):
-    test_source = """
-#include <openssl/ssl.h>
-int main() { SSL_CTX* ctx=NULL; EC_KEY* ecdh=NULL; return !SSL_CTX_set_tmp_ecdh(ctx,ecdh); }
-"""
-    context.Message('Checking for SSL_CTX_set_tmp_ecdh_() ... ')
-    result = context.TryLink(test_source, '.cpp')
-    context.Result(result)
-    return result
-
-def CheckVersionScript(context):

=== debian/changelog ===
galera-3 (25.3.31-2build1) hirsute; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 12 Dec 2020 13:06:32 +0100

galera-3 (25.3.31-2) unstable; urgency=medium

  * Fix i386 builds by forcing Scons to use DEB_HOST_ARCH if available
  * Fix arm64 build failure due to crc32 issue

 -- Otto Kekäläinen <otto@debian.org>  Fri, 06 Nov 2020 23:18:26 +0200

galera-3 (25.3.31-1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * New upstream version 25.3.31
  * Drop patches applied upstream
  * Remove d/copyright references to crc32 library that was removed upstream

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Submit, Repository.

 -- Otto Kekäläinen <otto@debian.org>  Mon, 02 Nov 2020 20:43:42 +0200

## galera-3 25.3.33

=== debian/changelog ===
galera-3 (25.3.33-1) unstable; urgency=low

  * New upstream version 25.3.33
  * Follow upstream change and switch from SCons to CMake. This
    is necessary, otherwise building from sources would fail.
  * Remove patches applied upstream or obsoleted by SCons->CMake change
  * Add Lintian overrides for libgalera_smm.so that are intentional

 -- Otto Kekäläinen <otto@debian.org>  Sat, 22 May 2021 11:49:07 -0700

=== debian/rules ===
#!/usr/bin/make -f

# Enable Debian Hardening
# https://wiki.debian.org/Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
# Include all defaults, including buildflags.mk
include /usr/share/dpkg/default.mk

override_dh_auto_test:
	dh_auto_test -O--no-parallel -- ARGS=--output-on-failure

# Start earlier than MySQL which has value 19
override_dh_installinit-arch:
	dh_installinit -n --name=garb -- defaults 18 22

%:
	dh $@

## galera-3 25.3.34

=== SConstruct ===
--- 
+++ 
@@ -98,15 +98,7 @@
 build_dir    = ''
 
 # Version script file
-galera_script = File('#/galera-sym.map').abspath
-with open(galera_script, 'w') as f:
-    f.write('''{
-    global: wsrep_loader;
-            wsrep_interface_version;
-    local:  *;
-};
-''')
-
+galera_script = File('#/galera/src/galera-sym.map').abspath
 
 #
 # Read commandline options
@@ -162,7 +154,7 @@
 install = ARGUMENTS.get('install', None)
 version_script = int(ARGUMENTS.get('version_script', 1))
 
-GALERA_VER = ARGUMENTS.get('version', '3.31')
+GALERA_VER = ARGUMENTS.get('version', '3.34')
 GALERA_REV = ARGUMENTS.get('revno', 'XXXX')
 
 # Attempt to read from file if not given
@@ -378,3 +370,9 @@
 int main() { SSL_CTX* ctx=NULL; return !SSL_CTX_set_ecdh_auto(ctx, 1); }
 """
     context.Message('Checking for SSL_CTX_set_ecdh_auto() ... ')
+    result = context.TryLink(test_source, '.cpp')
+    context.Result(result)
+    return result
+
+def CheckSetTmpEcdh(context):
+    test_source = """

=== debian/changelog ===
galera-3 (25.3.34-1build1) jammy; urgency=medium

  * No-change rebuild against openssl3

 -- Simon Chopin <simon.chopin@canonical.com>  Tue, 23 Nov 2021 16:18:18 +0100

galera-3 (25.3.34-1) unstable; urgency=medium

  * New upstream version 25.3.34. Includes multiple bug fixes, see
    https://github.com/codership/documentation/blob/master/release-notes/release-notes-galera-25.3.34.txt
  * Restore CK_TIMEOUT_MULTIPLIER in debian rules to avoid having
    various slow builds and CI runs fail in vain

 -- Otto Kekäläinen <otto@debian.org>  Mon, 02 Aug 2021 13:20:30 -0700

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
  https://releases.galeracluster.com/galera-3/source/galera-3-(.+).tar.gz
